
                         (* PINTCALCS.PAS *)

(* This program calculates standard errors for two-level designs.
   Programmed by Henk Guldemond and Tom Snijders.
   Transformed to Delphi under Windows by Tom Snijders*)

unit PintCalcs;

interface

CONST
  version = '2.12       september 2007';
  dimmax = 40;
(* Difference from version 2.11: only larger dimmax *)  

(* Q = AANTAL VARIABELEN MET RANDOM EFFECTEN OP LL. NIVO *)
(* R = X1 , AANTAL VARIABELEN OP SCHOOLNIVO              *)
(* S =      AANTAL GEAGREGEERDE VARIABELEN OP SCHOOLNIVO *)

TYPE MAT = ARRAY[1..dimmax,1..dimmax] OF REAL;
     VEC = ARRAY[1..dimmax]        OF REAL;
     TEKST = string[80];

PROCEDURE GETDATA;
procedure CalculateStandardErrors(infn, outfn1, outfn2: shortstring);

implementation

uses SysUtils;

TYPE
   RealArrayNP = ARRAY [1..dimmax] OF real;
   IntegerArrayNP = ARRAY [1..dimmax] OF integer;

VAR NSTUD,N :INTEGER;  (*NSTUD=AANTAL LL , N= SCHOLEN    *)
    V,V11,V12,V22                 : MAT;   (*UITKOMSTEN PER SUBMATRIX*)
    V11_1,V11_2,V11_3,V12_1,V22_1 : MAT;
    SIGMAW, SIGMAB, TAU2          : MAT;
    E,EP          :MAT;   (*INLEZEN MET J=1         *)
    MU3,MU1,MU3P  :MAT;  (* INLEZEN MET J=1        *)
    E22INV        :MAT;
    RESID      : REAL; (*RESIDUELE VARIANTIE     *)
   Q, R, S     : INTEGER;
   T           : TEKST;
   ax,bx,cx: textfile;
    (*extra rommel : *)
   nstudx,nx,kosten,extra,stap,start,eind :integer;
   indxx : IntegerArrayNP;
   col : RealArrayNP;
   dd : real;
    (*alweer klaar*)
    (* bijgevoegd voor Delphi versie : *)
   BudgetConstraint: boolean;
   n2min, n2step, n2max: integer;


PROCEDURE ludcmp(VAR a: MAT; n: integer;
                 VAR indx: IntegerArrayNP; VAR d: real);

CONST
   tiny=1.0e-20;
VAR
   k,j,imax,i: integer;
   sum,dum,big: real;
   vv : RealArrayNP;
BEGIN
   d := 1.0;
   FOR i := 1 to n DO BEGIN
      big := 0.000001;
(* This was 0 originally. *)
      FOR j := 1 to n DO
       IF (abs(a[i,j]) > big) THEN big := abs(a[i,j]);
      IF (big = 0.0) THEN BEGIN
         Writeln(bx,'pause in LUDCMP - singular matrix');
      END;
      vv[i] := 1.0/big
   END;
   FOR j := 1 to n DO BEGIN
     FOR i := 1 to j-1 DO BEGIN
       sum := a[i,j];
         FOR k := 1 to i-1 DO
            sum := sum-a[i,k]*a[k,j];
         a[i,j] := sum
     END;
     big := 0.0;
     FOR i := j to n DO BEGIN
      sum := a[i,j];
        FOR k := 1 to j-1 DO
        sum := sum-a[i,k]*a[k,j];
     a[i,j] := sum;
     dum := vv[i]*abs(sum);
     IF (dum > big) THEN BEGIN
         big := dum;
         imax := i
     END
 END;
 IF (j <> imax) THEN BEGIN
     FOR k := 1 to n DO BEGIN
        dum := a[imax,k];
        a[imax,k] := a[j,k];
        a[j,k] := dum
     END;
     d := -d;
     vv[imax] := vv[j]
 END;
 indx[j] := imax;
 IF (a[j,j] = 0.0) THEN a[j,j] := tiny;
 IF j <> n THEN BEGIN
    dum := 1.0/a[j,j];
         FOR i := j+1 to n DO
            a[i,j] := a[i,j]*dum
 end;
 END;
END;
PROCEDURE lubksb(VAR a: MAT; n: integer;
                 VAR indx: IntegerArrayNP;
                 VAR b: RealArrayNP);
VAR
   j,ip,ii,i: integer;
   sum: real;
BEGIN
   ii := 0;
   FOR i := 1 to n DO BEGIN
      ip := indx[i];
      sum := b[ip];
      b[ip] := b[i];
      IF  (ii <> 0) THEN
         FOR j := ii to i-1 DO
            sum := sum-a[i,j]*b[j]
      ELSE IF (sum <> 0.0) THEN
         ii := i;
         b[i] := sum
   END;
   FOR i := n DOWNTO 1 DO BEGIN
      sum := b[i];
         FOR j := i+1 to n DO
            sum := sum-a[i,j]*b[j];
         b[i] := sum/a[i,i]
   END
END;

PROCEDURE inverse(VAR yy: MAT; aa : MAT ; n : integer);

VAR col : RealArrayNP;
    i,j : integer;
BEGIN
  if (n <= 0) then
    begin yy[1,1] := 1.0; exit; end;  
  if (n = 1) then
    begin
      if (aa[1,1] = 0.0) then yy[1,1] := 1.0 else yy[1,1] := 1/aa[1,1];
      exit;
     end;
  ludcmp(aa,n,indxx,dd);
  for j := 1 to n do BEGIN
   for i := 1 to n do col[i] := 0.0;
   col[j] := 1.0;
   lubksb(aa,n,indxx,col);
   for i := 1 to N do yy[i,j] := col[i]  (* !!! *)
   END;
END;


PROCEDURE WM1(M :MAT; T : TEKST; R,K : INTEGER);
VAR I,J :INTEGER;
BEGIN
 Writeln(cx); Writeln(cx,T); Writeln(cx);
 FOR I := 1 TO R DO
  BEGIN
   FOR J := 1 TO K DO write(cx,m[i,j]:13:8);
   writeln(cx);
  END;
 writeln(cx); writeln(cx);
END;

PROCEDURE WMX(M :MAT; T : TEKST; R,K : INTEGER);
VAR I,J :INTEGER;
BEGIN
Writeln(bx,T);Writeln(bx);
 FOR I := 1 TO R DO
  BEGIN
   FOR J := 1 TO K DO
   Write(bx,M[I,J]:13:5);
   Writeln(bx);
  END;
Writeln(bx);
Writeln(bx);
END;


PROCEDURE KRONECKER(VAR C : MAT; A , B :MAT;P,Q,R,S:INTEGER);

VAR I,J,K,L,RYTOT,KOLTOT : INTEGER;

BEGIN
 RYTOt:=0;
 FOR I:=1 TO P DO
  BEGIN
   KOLTOt:=0;
   FOR J:=1 TO Q DO
    BEGIN
     FOR K:=1 TO R DO
      FOR L:= 1 TO S DO
      C[K+RYTOT,L+KOLTOT]:=A[I,J] * B[K,L];
      KOLTOt:=KOLTOT + S;
      END;
    RYTOt:=RYTOT +  R;
  END;
END;

PROCEDURE MATRIXMUL(VAR C:MAT;A,B:MAT;M,P,N:INTEGER);

VAR I,J,K:INTEGER;
        S:REAL   ;

BEGIN
 FOR I := 1 TO M DO
  BEGIN
   FOR J:=1 TO N DO
      BEGIN
     S:=0;
    FOR K:=1 TO P DO S:=S + A[I,K]* B[K,J];
       C[I,J]:=S;
     END;
  END;
END;

PROCEDURE MATRIXSUM(VAR C:MAT;A,B:MAT;M,N:INTEGER);

VAR I,J:INTEGER;

BEGIN
 FOR I := 1 TO M DO
   FOR J:=1 TO N DO
     C[I,J]:=A[I,J] + B[I,J];
END;

PROCEDURE TRANSPOSE(VAR C:MAT;A:MAT;R,K:INTEGER);

VAR I,J :INTEGER;

BEGIN
 FOR I:=1 TO R DO
  FOR J:=1 TO K DO
  C[J,I] := A[I,J];
END;

PROCEDURE PARTITION(VAR C:MAT; A:MAT;X1,X2,Y1,Y2:INTEGER);

VAR I,J : INTEGER;

BEGIN
 FOR I:=X1 TO X2 DO
  FOR J:=Y1 TO Y2 DO
   C[I-X1+1,J-Y1+1] := A[I,J]
END;

PROCEDURE CLEANMAT(VAR X:MAT);

VAR I,J :INTEGER;

BEGIN
 FOR I:= 1 TO dimmax DO
  FOR J:=1 TO dimmax DO
  X[I,J]:=0;
END;

PROCEDURE FIRSTCALCS(VAR EP, E22INV, MU3P, V11_1,V11_2,V11_3,
                         V12_1,V22_1: MAT);

VAR I,J: INTEGER;
    E22,A,B,C,D,AA: MAT;
(* Comments in Snijders-Bosker notation *)
BEGIN
(* first EP = E' and E22INV *)
  TRANSPOSE(EP,E,Q,1);
  MATRIXMUL(A,E,EP,Q,1,Q);
  PARTITION(B,SIGMAW,S+1,S+Q,S+1,S+Q);
  MATRIXSUM(E22,A,B,Q,Q);
  INVERSE(E22INV,E22,Q);
 (* now V11_1 = (SIGMAW11 - SIGMAW12*E22INV*SIGMAW21)/RESID *)
  PARTITION(A,SIGMAW,1,S,1,S);           (* SIGMAW11 *)
  PARTITION(AA,SIGMAW,1,S,S+1,S+Q);       (* SIGMAW12 *)
  TRANSPOSE(B,AA,S,Q);                    (* SIGMAW21 *)
  MATRIXMUL(D,AA,E22INV,S,Q,Q);
  MATRIXMUL(C,D,B,S,Q,S);
  FOR I:=1 TO S DO FOR J:=1 TO S DO V11_1[I,J] := (A[I,J] - C[I,J])/RESID;
(* now V11_2 = SIGMAB11 + MU1*MU1' *)
  PARTITION(A,SIGMAB,R+1,R+S,R+1,R+S);   (* SIGMAB11 *)
  TRANSPOSE(B,MU1,S,1);
  MATRIXMUL(C,MU1,B,S,1,S);
  MATRIXSUM(V11_2,A,C,S,S);
(* now V11_3 = SIGMAW12*E22INV *)
  MATRIXMUL(V11_3,AA,E22INV,S,Q,Q);
(* now MU3P = MU3' and V12_1 = MU1*MU3' + SIGMAB13 *)
 TRANSPOSE(MU3P,MU3,R,1);
 MATRIXMUL(B,MU1,MU3P,S,1,R);
 PARTITION(C,SIGMAB,R+1,R+S,1,R);        (* SIGMAB13 *)
 MATRIXSUM(V12_1,B,C,S,R);
(* finally V22_1 = MU3*MU3' + SIGMAB33 *)
  MATRIXMUL(B,MU3,MU3P,R,1,R);
  PARTITION(C,SIGMAB,1,R,1,R);
  MATRIXSUM(V22_1,B,C,R,R);
END; (* FIRSTCALCS *)

PROCEDURE NEWTERM(VAR V11,V12,V22: MAT);

VAR I,J :INTEGER;
    A,B,C,D,F : MAT;

BEGIN
(* first F *)
 FOR I:=1 TO Q DO FOR J:=1 TO Q DO
   A[I,J] := TAU2[I,J] + RESID*E22INV[I,J]/NSTUD;
 INVERSE(F,A,Q);
(* now V11 *)
 MATRIXMUL(B,EP,F,1,Q,Q);
 MATRIXMUL(C,B,E,1,Q,1);
 FOR I:=1 TO S DO FOR J:=1 TO S DO
   A[I,J] := NSTUD*V11_1[I,J] + C[1,1]*V11_2[I,J];
 TRANSPOSE(B,V11_3,S,Q);
 MATRIXMUL(C,V11_3,F,S,Q,Q);
 MATRIXMUL(D,C,B,S,Q,S);
 MATRIXSUM(V11,A,D,S,S);
(* now V12 *)
 MATRIXMUL(A,V11_3,F,S,Q,Q);
 KRONECKER(B,A,MU3P,S,Q,1,R);
 MATRIXMUL(A,EP,F,1,Q,Q);
 KRONECKER(C,A,V12_1,1,Q,S,R);
 MATRIXSUM(V12,B,C,S,Q*R);
(* and V22 *)
 KRONECKER(V22,F,V22_1,Q,Q,R,R);
END;

PROCEDURE COMBINE(VAR V: MAT);

VAR I,J:INTEGER;

BEGIN
 FOR I:=1 TO S DO
  FOR J:=1 TO S DO V[I,J]:= n*V11[I,J];
 FOR I:=1 TO S DO
  FOR J:=1 TO Q*R DO
   BEGIN V[I,J+S]:=n*V12[I,J]; V[J+S,I]:=n*V12[I,J]; END;
 FOR I:=1 TO Q*R DO
  FOR J:=1 TO Q*R DO V[S+I,S+J]:=n*V22[I,J]
END;


PROCEDURE GETDATA;

VAR I,J :INTEGER;
    NVAR : INTEGER;
(* OP INPUT STAAN RESP.
 << eerst symbolen uit Delphi source code Pintfm,
    dan symbolen uit PintCalcs = oude PINT >> 
   k     = NVAR : AANTAL VARIABELEN OP LL. NIVEAU INCL. CONSTANTE
   k1    = S    : AANTAL VARIABELEN MET VASTE EFFECTEN OP LL.NIVEAU
   kw    = R    : AANTAL VARIABELEN OP SCHOOLNIVEAU INC. CONSTANTE
   nmin  = start: aantal leerlingen per school waarmee we beginnen
   nstep = stap : de stapgrootte (aantal leerlingen dat per school toegvoegd
          wordt voor de volgende berekening begint)
   nmax  = eind : maximum aantal leerlingen per school
   bud   = kosten:in een nader te bepalen eenheid uit te drukken totale
          beschikbare gelden voor dataverzameling; uitgangspunt is dat de
          eenheid is uitgedrukt als: wat kost het om 1 leerling te
          onderzoeken
   c     = extra :de extra kosten die verbonden zijn aan het samplen van een
          nieuwe school (in dezelfde eenheid als 'kosten' uit te drukken)
  sigma2 = RESID : RESIDUELE VARIANTIE IN HET MODEL
  tau2   = TAU2    : onderdriehoekscovariantiematrix van de variantiecomponenten
  sigw   = SIGMAW  : covariantiematrix van de leerlingvariabelen
            eerst vaste EFFEcten, dan constante, dan random EFFEcten
  sigb   = SIGMAB  : covariantiematrix van de schoolvariabelen
            eerst constante, dan echte schoolvariabele, dan
            schoolgemiddelde van de leerlingvariabele met vaste EFFEcten
  mu1    = MU1     : gemiddelden van de schoolgemiddelden der leerlingvariabelen met
            vaste EFFEcten
  mu3    = MU3     : gemiddelden van de variabelen behorend bij sigma(s) m.u.v.
            schoolgemiddelden van leerlingvariabelen die zitten in MU1
  *)


BEGIN
(* First the input without the effects of the constant *)
 RESET(ax);
 read(ax, NVAR , S , R , start, stap , eind);
 Q := NVAR - S ;
 IF (S+(Q+1)*(R+1) > dimmax) THEN BEGIN
   WRITELN(bx);
   WRITELN(bx,'Constant dimmax is too small;');
   WRITELN(bx,'Must be at least k1 + (k-k1+1)*(kw+1) = ',S+(Q+1)*(R+1));
   Writeln(bx,'but is now only ',dimmax,'.');
   WRITELN(bx,'Program stops. SorrY! ');
   Writeln(bx,'Ask for a compilation with larger dimmax.');
   closefile(ax); closefile(bx); closefile(cx);
   exit;
  END;
 if (stap >= 0) then begin
   read(ax, kosten , extra );
   BudgetConstraint := true;
  end else begin
   read(ax, n2min, n2max);
   BudgetConstraint := false;
   stap := -stap;
   n2step := 1;
   if (n2max - n2min <= 20) then n2step := 1;
   if ((n2max - n2min > 20) and (n2max - n2min <= 50)) then n2step := 2;
   if ((n2max - n2min > 50) and (n2max - n2min <= 100)) then n2step := 5;
   if (n2max - n2min > 100) then n2step := 10;
  end; (* if *)
 read(ax,RESID);
 FOR I := 1 TO Q+1 DO
  FOR J := 1 TO I DO
   BEGIN
    read(ax,TAU2[I,J]);
    TAU2[J,I] := TAU2[I,J];
   END;
 FOR I := 2 TO Q+1 DO E[I,1]:=0;
 E[1,1] := 1;
 FOR I := 1 TO S+Q DO BEGIN
  FOR J := 1 TO I DO
   read(ax,SIGMAW[I,J]); readln(ax); END;
 FOR I := 1 TO R+S   DO BEGIN
  FOR J := 1 TO I   DO
   read(ax,SIGMAB[I,J]); readln(ax); END;
 FOR I := 1 TO S DO
  read(ax,MU1[I,1]);
 FOR I := 1 TO R DO
  read(ax,MU3[I,1]);

(* Now include the constant at the right places in the vectors and matrices *)

NVAR := NVAR+1;
R := R+1;
Q := Q+1;
for i:=R downto 2 do MU3[i,1] := MU3[i-1,1];
MU3[1,1] := 1.0;

for i:= NVAR downto S+2 do begin
  for j:=S+2 to NVAR do SIGMAW[i,j] := SIGMAW[i-1,j-1];
  for j:=1 to S do SIGMAW[i,j] := SIGMAW[i-1,j];
 end;
for j:=1 to S+1 do SIGMAW[s+1,j] := 0.0;
for i:=1 to NVAR do for j:=1 to i-1 do SIGMAW[j,i] := SIGMAW[i,j];

for i:= S+R downto 2 do begin
  for j:=2 to i do SIGMAB[i,j] := SIGMAB[i-1,j-1];
  SIGMAB[i,1] := 0.0;
 end;
SIGMAB[1,1] := 0.0;
for i:=1 to S+R do for j:=1 to i-1 do SIGMAB[j,i] := SIGMAB[i,j];

END; (* GetData *)


procedure CalculateStandardErrors(infn, outfn1, outfn2: shortstring);
var I: integer;
BEGIN
assignfile(ax,infn);  (*--------------voor pc only------------------*)
assignfile(bx,outfn1);  (*--------------voor pc only------------------*)
assignfile(cx,outfn2);  (*--------------voor pc only------------------*)
rewrite(bx); (*-------------------voor pc only----------------------*)
rewrite(cx); (*-------------------voor pc only----------------------*)
Writeln(bx);
Writeln(bx,'  PPPPPP       III    NNN      NNN  TTTTTTTTTTTTT');
Writeln(bx,'  PPP   PPP           NNNN     NNN       TTT');
Writeln(bx,'  PPP   PP     III    NNN NN   NNN       TTT');
Writeln(bx,'  PPPPPP       III    NNN  NN  NNN       TTT');
Writeln(bx,'  PPP          III    NNN   NN NNN       TTT');
Writeln(bx,'  PPP          III    NNN    NNNNN       TTT');
Writeln(bx,'  PPP          III    NNN     NNNN       TTT');
Writeln(bx,'  PPP          III    NNN      NNN       TTT');
Writeln(bx);
Writeln(bx,'            power in two-level designs');
Writeln(bx,'            version ', version);           
Writeln(bx);
Writeln(bx,'copyright:   roel bosker    (RUG)  & tom snijders (RUG)');
Writeln(bx,'programming: henk guldemond (RUG)  & tom snijders (RUG)');
Writeln(bx);
Writeln(bx,'This programs performs calculations corresponding to the paper');
Writeln(bx,'"Standard errors and Sample Sizes for Two-Level Research",');
Writeln(bx,'by Tom A.B. Snijders and Roel J. Bosker,');
Writeln(bx,'Journal of Educational Statistics, Vol. 18, 1993, p. 237-259.');
Writeln(bx);writeln(bx);
Writeln(bx,'Date and time: ', DateTimeToStr(Now));
Writeln(bx);
writeln(bx,'Input parameters read from file ',infn,'.');
writeln(bx);
writeln(bx,'File ',outfn2,' contains secondary output ');
writeln(bx,'(entire covariance matrices).');
Writeln(cx,DateTimeToStr(Now));
writeln(bx); writeln(cx);

GETDATA;

Writeln(bx,'Design:');
Writeln(bx,'(Between parentheses, the symbol is mentioned that is used for this parameter;');
Writeln(bx,' if the PINT manual uses a different symbol than the Snijders-Bosker paper,');
Writeln(bx,' then the symbol from the paper is given between parentheses,');
Writeln(bx,' the symbol from the manual between square brackets.)');
Writeln(bx);
Writeln(bx,'NUMBER OF FIXED EFFECTS              (K_1)            [L_1 + L_2 + 1] :',S :5);
Writeln(bx,'NUMBER OF RANDOM EFFECTS INCL. CONST (K_2)            [L_2 + 1]       :',Q :5);
Writeln(bx,'NUMBER OF LEVEL-2 VARS INCL. CONST   (length of W_3j) [L_3 + 1]       :',R :5);
if BudgetConstraint then begin
  Writeln(bx,'TOTAL COSTS                          (k)              [K]             :',kosten :5);
  Writeln(bx,'RELATIVE COST PER LEVEL-2 UNIT       (c)                              :',extra  :5);
 end;
Writeln(bx,'SMALLEST VALUE OF n                                   [n_min]         :',start :5);
Writeln(bx,'STEP SIZE FOR n                                       [n_step]        :',stap :5);
Writeln(bx,'LARGEST VALUE FOR n                                   [n_max]         :',eind :5);
if (not BudgetConstraint) then begin
  Writeln(bx,'SMALLEST NUMBER OF GROUPS                             [N_2min]        :',n2min  :5);
  Writeln(bx,'LARGEST NUMBER OF GROUPS                              [N_2max]        :',n2max  :5);
 end;
Writeln(bx);
Writeln(bx,'Parameters:'); Writeln(bx);
t:='WITHIN-GROUPS COVARIANCE MATRIX  (SIGMA-W)        ';
WMX(SIGMAW,T,S+Q,S+Q);
t:='BETWEEN-GROUPS COVARIANCE MATRIX (SIGMA-B)        ';
WMX(SIGMAB,T,R+S,R+S);
Writeln(bx,'RESIDUAL VARIANCE (sigma-squared)');
Writeln(bx);
Writeln(bx,RESID:17:5);
Writeln(bx);
t:='COVARIANCE MATRIX OF RANDOM EFFECTS (tau_2)       ';
WMX(TAU2,T,Q,Q);
t:='EXPECTATION OF LEVEL-1 VARIABLES WITH FIXED EFFECTS (mu_1)  ';
WMX(MU1,T,S,1);
t:='EXPECTATION OF LEVEL-2 VARIABLES (mu_3)             ';
WMX(MU3,T,R,1);
t:='CONSTANT MEAN VECTOR (mu_2 = e)                   ';
WMX(E,T,Q,1);
Writeln(bx);

if (S + Q*R > dimmax) then begin
  writeln(bx,'These specifications imply k1 + (k-k1)*kw = ',S+Q*R,' regression coefficients.');
  writeln(bx,'This is too many to handle for this program.');
  writeln(bx,'The maximum is', dimmax,'.'); writeln('Sorry!'); writeln;
 end else begin
(* hier komt het EIGEN brouwsel *)
FIRSTCALCS(EP, E22INV, MU3P, V11_1,V11_2,V11_3,V12_1,V22_1);
Writeln(bx,'The following table contains the standard errors (s.e.):');
Writeln(bx,'Fixed:   s.e. of regr. coeff.s of level-1 variables with a fixed effect only.');
Writeln(bx,'Const:   s.e. of the intercept.');
if (R >= 2) then Writeln(bx,'Group:   s.e. of regr. coeff.s of level-2 variables.');
if (Q >= 2) then begin
  Writeln(bx,'Random:  s.e. of regr. coeff.s of level-1 variables with a random effect.');
  Writeln(bx,'Cross-L: s.e. of regr. coeff.s of cross-level interactions');
  Writeln(bx,'         (product of "Group" with "Random effect" variables).');
 end;
Writeln(bx); Writeln(bx);
if BudgetConstraint then
  Writeln(bx,'    Sample sizes      costs   Standard errors   ')
 else  Writeln(bx,'    Sample sizes      Standard errors   ');
Writeln(bx);
if BudgetConstraint then Write(bx,'    N*n     N     n (n+c)*N   ')
 else Write(bx,'    N*n     N     n   ');
FOR I:=1 TO S DO BEGIN
Write(bx,' Fixed  '); END;
Write(bx,' Const  ');
FOR I:=1 TO R-1 DO BEGIN
Write(bx,' Group  '); END;
FOR I:=1 TO Q-1 DO BEGIN
Write(bx,' Random ');END;
FOR I:=1 TO (Q-1)*(R-1) DO BEGIN
Write(bx,'Cross-L ');END;
Writeln(bx);

if BudgetConstraint then nx:=1 else nx := n2min;
nstudx:=start;
while nstudx < eind+1 do begin
  if BudgetConstraint then begin
    nx:=trunc(kosten/(nstudx+extra));
   end;
  n:=nx;
  nstud:=nstudx;
  (* hier is het eerste afgelopen; kijk echter verderop; het
  gaat om een loop*)
  NEWTERM(V11,V12,V22);
  COMBINE(V);
  V11 := V;
  INVERSE(V22,V11,S+Q*R);
  t:='Covariance matrix of estimated coefficients       ';
  writeln(cx,'N = ',n,' ; n     = ',nstud);
  WM1(V22,T,S+Q*R,S+Q*R);
  MATRIXMUL(V12,V11,V22,S+Q*R,S+Q*R,S+Q*R);
  MATRIXMUL(V12,V22,V11,S+Q*R,S+Q*R,S+Q*R);
  Write(bx,N*NSTUD:7);
  Write(bx,N:6);
  Write(bx,NSTUD:6);
  if BudgetConstraint then Write(bx,N*(NSTUD+extra):8,'  ') else Write(bx,'  ');
   FOR I:= 1 TO S+Q*R DO
    BEGIN
    IF (V22[I,I] >= 1E-20) THEN
    write(bx,SQRT(V22[I,I]):8:5)
    else write(bx,' -.99999');
    END;
  Writeln(bx);
  (* en hier ging het brouwsel verder*)
  if BudgetConstraint then
    nstudx:=nstudx+stap
   else begin
    nx := nx + n2step;
    if (nx > n2max) then begin
      nx := n2min;
      nstudx := nstudx + stap;
     end;
    end;
 end;
(*waarna het hier definitief ten einde kwam*)
 end;
closefile(ax); (*-------------voor pc only--------------*)
closefile(bx); (*-------------voor pc only--------------*)
closefile(cx); (*-------------voor pc only--------------*)

end; (* CalculateStandardErrors *)

begin
end.

